class ComputerPlayer
{

ChessMoveChecker bord;
int player;

ComputerPlayer(ChessMoveChecker parent)
{
  bord = parent;
  player = parent.computercolor;
}

// Overloading: findmove tries to find the best move.
// No argument: main function
// ChessMoveChecker: the board is given
// ChessMoveChecker and Move: evaluate how good this particular move is.

public Move findmove ()
{
  return findmove(bord);
}

public static Move findmove (ChessMoveChecker bord1)
{
  int player = 1-bord1.lastplayermoved;
  return findmove (bord1,player);
}

public static Move findmove (ChessMoveChecker bord1, int player)
{
  int aantalrijen = bord1.aantalrijen;
  int aantalkolommen = bord1.aantalkolommen;
  Move themove = new Move();
  int bestmove = -50000;

  for (int i1=0; i1<aantalkolommen; i1++)
  {
   for (int j1=0; j1 < aantalrijen; j1++)
   {
    if (!bord1.EmptySquare(i1,j1))
    {
     if (bord1.PieceOwner(i1,j1)==player)
     {
      for (int i2=0; i2<aantalkolommen; i2++)
      {
       for (int j2=0; j2<aantalrijen; j2++)
       {
	if (bord1.LegalMove(i1,j1,i2,j2))
	{
	 Move tryit = new Move(i1,j1,i2,j2);
         int tryevaluate = Evaluate(bord1,tryit);
         if (tryevaluate > bestmove)
         { themove = tryit; bestmove = tryevaluate;
         }
        }
       }
      }
     }
    }
   }
  }
  return themove;
}

// evaluate the move. Rather crude. Just zero plies deep! Or is it 1/2?
static int Evaluate (ChessMoveChecker positie, Move zet)
{
return 1+ (int) (Math.random() * 100);
//  ChessMoveChecker aftermove = new ChessMoveChecker(positie);
//  aftermove.DoMove(zet);
//  return Evaluate(aftermove);
}

static int Evaluate (ChessMoveChecker positie)
{
  int player = 1- positie.lastplayermoved;

// if the other player is mated, then the value is very high.
  if (positie.Mated(1-player)) return 50000;
// if the other player is stalemated, then the value is zero: draw.
  if (positie.Stalemated(1-player)) return 0;
// compute the difference in value of the pieces
  int totvalue = diffvalueofpieces(positie,player);
//just add a random number between 1 and 10!
   int ran = 1+ (int) (Math.random() * 10);
   return ran + 10*totvalue;
}

// what is the value of the pieces of player minus the value of its opponent?
static int diffvalueofpieces (ChessMoveChecker positie, int player)
{
   int totvalue = 0;
   for (int k=0; k<positie.aantalkolommen; k++)
   {
    for (int r=0; k<positie.aantalrijen;r++)
    {
     if (!positie.EmptySquare(k,r))
     {
      if (positie.PieceOwner(k,r)==player)
      {
       totvalue += PieceValue(positie.bord[k][r]);
      }
      else
      {
       totvalue -= PieceValue(positie.bord[k][r]);
      }
     }
    }
   }
   return totvalue;
}

// give value of piece, notated as integer.
static int PieceValue(int piece)
{
   switch (piece)
   {
    case 0: return 0;
    case 1: return 0; // king. We're not counting this one.
    case 2: return 0; // king. And neither this one.
    case 3: return 8; // queen
    case 4: return 8; // queen
    case 5: return 5; // rook
    case 6: return 5; // rook
    case 7: return 3; // knight
    case 8: return 3; // knight
    case 9: return 3; // bishop
    case 10: return 3; // bishop
    case 11: return 1; // pawn
    case 12: return 1; // pawn
    case 13: return 8; // chancellor
    case 14: return 8; // chancellor
    case 15: return 6; // marshal
    case 16: return 6; // marshal
   }
   return 0;
}
}
